unit MainFrm;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Controls.Presentation, FMX.StdCtrls,
  Androidapi.JNI.AlarmReceiver, FMX.Layouts, FMX.DateTimeCtrls;

type
  TFormMain = class(TForm)
    ButtonAlarm: TButton;
    TimeEditAlarm: TTimeEdit;
    Layout1: TLayout;
    procedure ButtonAlarmClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.fmx}

uses
  AndroidAPi.Helpers, Androidapi.JNI.GraphicsContentViewText, Androidapi.JNI.JavaTypes, Androidapi.JNI.App,
  System.DateUtils;

function DateTimeLocalToUnixMSecGMT(const ADateTime: TDateTime): Int64;
begin
  Result := DateTimeToUnix(ADateTime) * MSecsPerSec - Round(TTimeZone.Local.UtcOffset.TotalMilliseconds);
end;

procedure TFormMain.ButtonAlarmClick(Sender: TObject);

  function CreateAlarmIntent(const AID: Integer): JPendingIntent;
  var
    Intent: JIntent;
  begin
    Intent := TJIntent.Create;
    Intent.setClass(TAndroidHelper.Context, TJlang_Class.Wrap(TJAlarmReceiver.GetClsID));
    Result := TJPendingIntent.JavaClass.getBroadcast(TAndroidHelper.Context, AID, Intent,
      TJPendingIntent.JavaClass.FLAG_UPDATE_CURRENT);
  end;

var
  PendingIntent: JPendingIntent;
begin
  PendingIntent := CreateAlarmIntent(1);

  TAndroidHelper.AlarmManager.&set(TJAlarmManager.JavaClass.RTC_WAKEUP, DateTimeLocalToUnixMSecGMT(Date + TimeEditAlarm.Time),
    PendingIntent);
end;

end.
